{  Copyright (C) 1996 Ruslan Fazliev }
uses CRT;
type
  TDir=record
    x,y:integer;
  end;
  TOneHead=record
    x,y:integer;
  end;
const
  Filename='MAZE.DAT';
  dirN=0;
  dirNE=1;
  dirE=2;
  dirSE=3;
  dirS=4;
  dirSW=5;
  dirW=6;
  dirNW=7;
  dirStart=8;
  dirNoWay=9;
  Directions:array[dirN..dirNW] of TDir=(
    (x:0;y:-1),
    (x:1;y:-1),
    (x:1;y:0),
    (x:1;y:1),
    (x:0;y:1),
    (x:-1;y:1),
    (x:-1;y:0),
    (x:-1;y:-1));
type
  TLevel=array[1..25,1..80] of boolean;
  TNode=record
    moves:word;
    dir:byte;
  end;
  TMoveMap=array[1..25,1..80] of TNode;
  TVMRec=record
    c:char;
    attr:byte;
  end;
var
  Level:TLevel;
  MoveMap:TMoveMap;
  x,y,x1,y1,x2,y2:integer;
  VideoMem:array[1..25,1..80] of TVMRec absolute $B800:0;
  F:File of TLevel;
label
  MainLoop;
procedure DisplayMap;
var
  x,y:integer;
begin
  for y:=1 to 25 do
    for x:=1 to 80 do
      if ((x<>x1) or (y<>y1)) and ((x<>x2) or (y<>y2)) then
      begin
        if Level[y,x] then
          VideoMem[y,x].c:=''
        else
          VideoMem[y,x].c:='';
        VideoMem[y,x].attr:=LightGreen;
      end
      else
      begin
        VideoMem[y,x].attr:=LightRed;
        if (x=x1) and (y=y1) then
          VideoMem[y,x].c:='A'
        else
          VideoMem[y,x].c:='B';
      end;
end;
procedure MakeMove(Show:boolean);
var
  x,y,i,h:integer;
  m:integer;
  AllDone:boolean;
  Heads:array[0..1999] of TOneHead;
  MaxHead:integer;
procedure InsertHead(x,y,m:integer;d:byte);
var
  i:integer;
begin
  MoveMap[y,x].Dir:=d;
  MoveMap[y,x].Moves:=m;
  if Show then
  begin
    VideoMem[y,x].c:=Chr(M mod 10+48);
    VideoMem[y,x].attr:=1+ M div 10;
  end;
  for i:=0 to MaxHead do
    if (Heads[i].x=x) and (Heads[i].y=y) then
      Exit;
  inc(MaxHead);
  Heads[MaxHead].x:=x;
  Heads[MaxHead].y:=y;
end;
procedure DeleteHead(h:integer);
var
  i:integer;
begin
  for i:=h to MaxHead-1 do
    Heads[i]:=Heads[i+1];
  dec(MaxHead);
end;
procedure TryMove(h:integer);
var
  i,x,y,x_,y_,m:integer;
  d:byte;
begin
  x:=Heads[h].x;
  y:=Heads[h].y;
  m:=MoveMap[y,x].moves+1;
  for i:=0 to 7 do
  begin
    y_:=y+Directions[i].y;
    x_:=x+Directions[i].x;
    if (x_>=1) and (x_<=80) and (y_>=1) and (y_<=25) then
      if (MoveMap[y_,x_].Moves>m) and not Level[y_,x_] then
      begin
        AllDone:=false;
        if i>=4 then
          d:=i-4
        else
          d:=i+4;
        InsertHead(x_,y_,m+d and 1,d);
      end;
  end;
  if Show then
  begin
    VideoMem[y,x].c:=Chr(MoveMap[y,x].Moves mod 10+48);
    VideoMem[y,x].attr:=1+ MoveMap[y,x].Moves div 10;
  end;
  DeleteHead(h);
end;
begin
  for y:=1 to 25 do
    for x:=1 to 80 do
    begin
      MoveMap[y,x].Moves:=65535;
      MoveMap[y,x].Dir:=dirNoWay;
    end;
  MoveMap[y1,x1].Moves:=0;
  MoveMap[y1,x1].Dir:=dirStart;
  MaxHead:=0;
  Heads[0].x:=x1;
  Heads[0].y:=y1;
  repeat
    AllDone:=true;
    for h:=0 to MaxHead do
      TryMove(0);
  until AllDone;
end;
procedure WalkThru;
var
  x,y,xo:integer;
begin
  if (x1=x2) and (y1=y2) then
    Exit;
  x:=x2;
  y:=y2;
  if MoveMap[y,x].Dir=dirNoWay then
  begin
    Sound(500);
    Delay(10);
    Sound(600);
    Delay(10);
    Sound(700);
    Delay(20);
    NoSound;
    Exit;
  end;
  repeat
    VideoMem[y,x].Attr:=White;
    VideoMem[y,x].C:=#4;
    xo:=x;
    inc(x,Directions[MoveMap[y,x].Dir].X);
    inc(y,Directions[MoveMap[y,xo].Dir].y);
  until (x=x1) and (y=y1);
end;
begin
  x1:=10;
  y1:=10;
  x2:=70;
  y2:=15;
  DisplayMap;
  MainLoop:
    case ReadKey of
      #27:
        Halt;
      ' ':
      if ((WhereX<>x1) or (WhereY<>y1)) and ((WhereX<>x2) or (WhereY<>y2)) then
        begin
          Level[WhereY,WhereX]:=not Level[WhereY,WhereX];
          DisplayMap;
        end;
      '1':
      begin
        x1:=WhereX;
        y1:=WhereY;
        Level[y1,x1]:=false;
        DisplayMap;
      end;
      '2':
      begin
        x2:=WhereX;
        y2:=WhereY;
        Level[y2,x2]:=false;
        DisplayMap;
      end;
      #9:
      begin
        MakeMove(True);
        ReadKey;
        DisplayMap;
      end;
      #13:
      begin
        MakeMove(False);
        WalkThru;
        ReadKey;
        DisplayMap;
      end;
      #0:
        case ReadKey of
          #$48:
            GoToXY(WhereX,WhereY-1);
          #$4B:
            GoToXY(WhereX-1,WhereY);
          #$4D:
            GoToXY(WhereX+1,WhereY);
          #$50:
            GoToXY(WhereX,WhereY+1);
          #$3C:
          begin
            Assign(F,Filename);
            Rewrite(F);
            Write(F,Level);
            Close(F);
          end;
          #$3D:
          begin
            Assign(F,Filename);
            Reset(F);
            Read(F,Level);
            Close(F);
            DisplayMap;
          end;
        end;
    end;
  goto MainLoop;
end.