// GWave.h: interface for the GWave class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _GWAVE_H_
#define _GWAVE_H_

typedef unsigned char WBYTE;
typedef WBYTE* LPWBYTE;

static const WBYTE END_POINT	= 0;
static const WBYTE NOPASS_POINT	=-1;
static const WBYTE PASS_POINT	=-2;
static const WBYTE START_POINT	=-3;
static const WBYTE MAX_WAVES	=-4;

struct WPOINT
{
	int x;
	int y;
};

class GWave  
{
	WBYTE nWave;
	int nWavePoints;
	LPWBYTE *ppWave;
	LPWBYTE *ppWaveTmp;	
	WPOINT dxy[8];
	int    ofs[8];
	bool GenerateWave();

public:

	WBYTE *pWorld;
	int nWidth, nHeight;	

	GWave( int w, int h );
	int GetWay( WPOINT *pDPoints, WBYTE nMaxCount, WPOINT ptStart, WPOINT ptEnd );
	void DrawBorder();
	virtual ~GWave();
};


#endif
