{$M 1024, 0, 0}
Uses Crt;

Const
  Wall = -1 ; Start = -2 ; Finish = -3  ;
  Up   =  1 ; Left  =  2 ; Down   =  3  ; Right = 4;
  M    = 19 ; N     = 14 ;

Var
  F      : File                              ;
  Map    : Array[ 1 .. M, 1 .. N ] Of Integer;
  Font   : Integer                           ;
  I, J   : Integer                           ;
  X, Y, V: Byte                              ;

Function InStep( V: Byte ): Integer;
  Begin
    If V = Up    Then InStep := Map[ X    , Y - 1 ];
    If V = Left  Then InStep := Map[ X - 1, Y     ];
    If V = Down  Then InStep := Map[ X    , Y + 1 ];
    If V = Right Then InStep := Map[ X + 1, Y     ]
  End;

Function Done: Boolean;
  Begin
    If ( InStep( Up    ) = Finish ) Or
       ( InStep( Left  ) = Finish ) Or
       ( InStep( Down  ) = Finish ) Or
       ( InStep( Right ) = Finish ) Then Done := True Else Done := False
  End;

Procedure Step;
  Begin
    V := 255;

    If ( InStep( Up    ) > -1 ) And ( InStep( Up    ) < InStep( V ) ) Then V := Up   ;
    If ( InStep( Left  ) > -1 ) And ( InStep( Left  ) < InStep( V ) ) Then V := Left ;
    If ( InStep( Down  ) > -1 ) And ( InStep( Down  ) < InStep( V ) ) Then V := Down ;
    If ( InStep( Right ) > -1 ) And ( InStep( Right ) < InStep( V ) ) Then V := Right;


    If V = Up Then
      Begin
        Inc( Map[ X, Y ] ) ; GoToXY( X, Y ) ; Write( ' ' ) ; Dec( Y );
      End;

    If V = Down Then
      Begin
        Inc( Map[ X, Y ] ) ; GoToXY( X, Y ) ; Write( ' ' ) ; Inc( Y );
      End;

    If V = Left Then
      Begin
        Inc( Map[ X, Y ] ) ; GoToXY( X, Y ) ; Write( ' ' ) ; Dec( X );
      End;

    If V = Right Then
      Begin
        Inc( Map[ X, Y ] ) ; GoToXY( X, Y ) ; Write( ' ' ) ; Inc( X );
      End;

    GoToXY( X, Y ) ; Write( '' ) ; Delay( 50 )
  End;

Begin
  ClrScr ; Assign( F, ParamStr( 1 ) ) ; Reset( F, 1 );

  For Y := 1 To N Do
    For X := 1 To M Do
      Begin
        BlockRead( F, Map[ X, Y ], 1 ) ; GoToXY( X, Y ) ; Write( Chr( Map[ X, Y ] ) );
        If Map[ X, Y ] = 219 Then Map[ X, Y ] := Wall  ;
        If Map[ X, Y ] =  83 Then Map[ X, Y ] := Start ;
        If Map[ X, Y ] =  70 Then Map[ X, Y ] := Finish;
        If Map[ X, Y ] =  32 Then Map[ X, Y ] := 0     ;
      End;

  V := Down ; X := 2 ; Y := 2 ; While Not Done Do Step
End.